/*
	CDRemaining - An XFCN to report remaining time on disc
	Apple Computer, Inc. 1988
	All Rights Reserved.
	
	88/11/08	BLB	First Version

	To compile and link this file using Macintosh Programmer's Workshop,

	C -q2 CDRemaining.c
	link -sn Main=CDRemaining -sn STDIO=CDRemaining 
		 -sn INTENV=CDRemaining -rt XFCN=42 
		 -m CDRemaining CDRemaining.c.o "{CLibraries}"CRuntime.o 
		 "{CLibraries}"StdCLib.o 
		 -o HyperCommands
		 
	This link directive puts the XCMD in the file "HyperCommands".
	Substitute the name of the stack you want it in.  To move XCMDs
	between stacks, use ResEdit.  They can be in an individual stack,
	the Home stack, the HyperCard application, or the System File.
	
*/

#include <cd.h>

/* prototype definitions for functions */
OSErr	ReadQ(short, long *, long *, long *, long *);
OSErr	ThisDisc(short, long *, long *, long *);
void	TimeDiff(long *, long *, long *, long, long, long, long, long, long);
OSErr	NextTrack(long, long, long *, long *, long *);

/* **** WARNING:  DO NOT USE GLOBAL VARIABLES! **** */


/************************************************************************
 *
 *  Function:		CDRemaining
 *
 *  Purpose:		return the remaining time on this disc.
 *
 *  Returns:		either 0, or an error
 *					if it's a negative number, it's an error
 *
 *  Side Effects:
 *
 *  Description:	We need no parameter:
 *					Get the ioRefNum that we got from previously calling
 *					CDOpen() by accessing the famous global
 *					call the driver to find the current position.  Call
 *					the driver to get the lead-out time (end of disc time)
 *					Subtract the two and return the result.
 *
 ************************************************************************/
pascal void
CDRemaining(paramPtr)
XCmdBlockPtr	paramPtr;
{
	Str31	returnString;
	OSErr	result;
	short	ioRefNum;
	Handle	refHandle;
	long	Remaining[4];	/* minute, second, block */
	long	currentMinute, currentSecond, currentBlock;
	long	startMinute, startSecond, startBlock;
	
	/* Must be no parameter */
	if ((paramPtr->paramCount) != 0)
	{
		/* Report error in parameters by returning -1 */
		NumToStr(paramPtr, (long) -1, &returnString);
		paramPtr->returnValue = PasToZero(paramPtr, (StringPtr) &returnString);
		return;
	}
	
	/* Get the global ioRefNum and convert it. */
	refHandle = GetGlobal(paramPtr, GLOBALNAME);
	ioRefNum = atoi(*(refHandle));
	DisposHandle(refHandle);
	ioRefNum &= 0xFFFF;			/* remove vRefNum; not needed. */
	
	
	result = ReadQ(ioRefNum, &Remaining[0], &currentMinute, &currentSecond, &currentBlock);
	
	if (result == noErr)
		result = DiscTime(ioRefNum, &startMinute, &startSecond, &startBlock);
		
	if (result == noErr)
	{
		TimeDiff(&Remaining[1], &Remaining[2], &Remaining[3],
				 startMinute, startSecond, startBlock,
				 currentMinute, currentSecond, currentBlock);
	}

	if (result == noErr)
	{
		/* convert each value to a string, concatenate, & return. */
		FormatString(&returnString, Remaining, 4);
		paramPtr->returnValue = PasToZero(paramPtr, (StringPtr) &returnString);
	}
	else
	{
		/* We got an error. Convert result to string & return it as error */
		NumToStr(paramPtr, (long) result, &returnString);
		paramPtr->returnValue = PasToZero(paramPtr, (StringPtr) &returnString);
	}
}


/* C routines for HyperCard callbacks */
#include <XCmdGlue.inc.c>
