(*
	CTBVersion() -- Return the current version as a list consisting of the
		Toolkit version, the date of that version, and the Comm Toolbox version.

	To compile and link this file using Macintosh Programmer's Workshop,

		pascal -w CTBVersion.p
		link -m ENTRYPOINT -o HyperCommands -rt XFCN=2750 -sn Main=CTBVersion 
			CTBVersion.p.o "{MPW}"Libraries:Libraries:HyperXLib.o

	 Copyright 1990 by Apple Computer, Inc.

	Initial coding 2/90 by Harry R. Chesley.
*)

{$R-}

{$S CTBVersion } 	{ Segment name must be the same as the command name. }

unit DummyUnit;

interface

uses MemTypes, QuickDraw, OSIntf, ToolIntf, CTBUtils, FTIntf, CMIntf, TMIntf, CRMIntf, HyperXCmd;

procedure EntryPoint(paramPtr: XCmdPtr);
	
implementation

procedure CTBVersion(paramPtr: XCmdPtr); forward;

procedure EntryPoint(paramPtr: XCmdPtr);

	begin
		CTBVersion(paramPtr);
	end;

procedure CTBVersion(paramPtr: XCmdPtr);

	{$I CTBUtil.inc}

	var s: Str255;

	procedure Fail(errMsg: Str255); { set theResult and quit }
		begin
			paramPtr^.returnValue := PasToZero(paramPtr,errMsg);
			exit(CTBVersion);
		end;

	begin
		{ Determine if the Comm Toolbox is installed in this system. }
		if CTBInstalled then LongToStr(paramPtr,CTBGetCTBVersion,s)
		else s := 'not installed';
		paramPtr^.returnValue := PasToZero(paramPtr,Concat('1.0b2,10/23/90,CTB ',s))
	end;

end.
