<<
class ANTLRToken : public DLGBasedToken {
public:
	int muck;
public:
    ANTLRToken(TokenType t, ANTLRChar *s) : DLGBasedToken(t)
		{ muck = atoi(s); }
    ANTLRToken() {;}
    ANTLRChar *getText() { return ""; }
    void setText(ANTLRChar *s) { ; }
    virtual ANTLRLightweightToken *makeToken(TokenType t, char *s, int line)
		{
			ANTLRToken *tk = new ANTLRToken;
			tk->setType(t); tk->muck = atoi(s);
			return tk;
		}
};

#include "DLGLexer.h"

int main()
{
	ANTLRToken aToken;
	DLGFileInput in(stdin);
	DLGLexer scan(&in,2000);
	ANTLRTokenBuffer pipe(&scan);
	scan.setToken(&aToken);
	Expr parser(&pipe);
	parser.init();

	parser.calc();
	return 0;
}
>>

#token "[\ \t\n]+"	<<skip();>>

class Expr {

calc:	<<int r;>>
		e>[r]
		<<printf("result is %d\n", r);>>
	;

e > [int r]
	:	<<int b;>>
		e2>[$r] ( "\+" e2>[b] <<$r+=b;>> )*
	;

e2 > [int r]
	:	NUMBER <<$r=$1->muck;>>
		( "\*" NUMBER <<$r*=$2->muck;>> )*
	;

}

#token NUMBER		"[0-9]+"

